<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden'"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div v-if="field.mobile&&field.hiddenValue" class="select_about-vertical">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div class="select_about-vertical">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div>
          <mt-checklist
            @change="onChange"
            v-model="value"
            :options="field.options">
          </mt-checklist>
        </div>
      </div>
    </template>

    <template v-else-if="field.textType == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template>
        <!-- 只读（控件模式） -->
        <div class="select_about-vertical">
          <div class="titleName">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <div>
            <mt-checklist
              @change="onChange"
              v-model="value"
              :options="field.options">
            </mt-checklist>
          </div>
        </div>
      </template>
    </template>
    
  </span>
</template>

<script>
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-select-about",
  props: ["id"],
  computed: {
    field: function() {
      let allData = this.$parent.findField(this.id);
      if(allData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(allData.discript.charAt(allData.discript.length - 1) == "*") {
          allData.discript = allData.discript.replace(/(\s|\*)+$/g, '');
          allData.essential = true;
        }
      }
      if(allData.displayType == 1 || allData.displayType == 4) {
        for(let i=0; i<allData.options.length; i++) {
          allData.options[i].disabled = true;
        }
      }
      allData.options = JSON.parse(JSON.stringify(allData.options).replace(/option/g,"label"));
      return allData;
      //return this.$parent.findField(this.id);
    },
    value: {
      get: function() {
        return (this.field.value).split(";");
      },
      set: function(newValue) {
        this.field.value = newValue.join(";").replace(/^(\s|;)+|(\s|;)+$/g, '');
      }
    },
 
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return { Constant };
  },

  methods: {
    onChange() {
      if (this.field.refreshOnChanged) {//判断是否需要刷新
        // this.$parent.refresh(this.id);
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + "'"+ this.id +"'" + ')';
            eval(path);
            break
          }
        }
      }
    },
  }
};
</script>
